from math import pi

class Vortex(object):
    def __init__(self, pos=0.0, strength=1.0):
        self.position = pos
        self.strength = strength
        self.velocity = complex(0, 0)

    def eval_velocity(self, pos):
        return -1j*self.strength/(2*pi*(pos - self.position))

class VortexManager(object):
    def __init__(self, vortices=None):
        self.vortices = []
        if vortices is not None:
            self.vortices = vortices

    def set(self, pos, str):
        self.vortices = []
        for i in xrange(len(pos)):
            v = Vortex(pos[i], str[i])
            self.vortices.append(v)

    def eval_velocity(self, pos):
        vel = complex(0, 0)
        for x in self.vortices:
            vel += x.eval_velocity(pos)
        return vel

    def velocity(self):
        """Velocity on itself."""
        for va in self.vortices:
            vel = complex(0, 0)
            for vb in self.vortices:
                if va is vb:
                    continue
                else:
                    vel += vb.eval_velocity(va.position)
            va.velocity = vel

