from distutils.core import setup
from distutils.extension import Extension

# ------------------------------------------
# Cython setup.
from Cython.Distutils import build_ext
setup(
  name = 'Perf',
  ext_modules=[
    Extension("vortex",       ["vortex.pyx"]),
    ],
  cmdclass = {'build_ext': build_ext}
)

# ------------------------------------------
# SWIG setup.
import numpy
numpy_include = numpy.get_include()
from numpy.distutils.core import setup, Extension
setup(name='swig',
        ext_modules=[Extension('_simple', ['simple.i'],
                                depends=['simple.hpp'],
                                extra_compile_args=["-O2"],
                                include_dirs=[numpy_include, '.'])]
        )

# ------------------------------------------
# PyD setup.
try:
    from celerid.support import setup, Extension
    setup(name='dee',
          ext_modules = [Extension("dee", ["dee.d"],
                                   extra_compile_args=["-O"],
                                   )]
         )
except ImportError:
    print '='*80
    print "You don't have PyD installed, not building D extension."
    print '='*80

